class Game
  attr_accessor :workers, :buildings, :stores,
                :room, :history, :outside,
                :events, :world,
                :tick_count, :game_state, :perks,
                :cost_string, :ship_thrusters, :ship_hull,
                :lift_off_after, :current_lift_off_ticks, :ship_base_thrusters,
                :fastest_completion_ticks, :last_battle_tick_result,
                :completed_once, :save_path, :base_path, :previous_active_module_history,
                :is_production, :language, :version, :base_save_path

  def active_module= value
    previous_active_module! @active_module, value
    @active_module = value
  end

  def active_module
    @active_module
  end

  def go_to_sulphur_mine
  end

  def go_to_final_stage
  end

  def tick_speed
    0.7 #in seconds
  end

  def builder_gather_rate
    5
  end

  def builder_gathers_wood
    return if @stores[:her_locket]
    return if !@room.builder_ready?
    return if (@tick_count % 10) != 0

    @stores[:wood] ||= 0
    @stores[:wood] += builder_gather_rate
  end

  def determine_if_at_final_stage
  end

  def at_final_stage?
  end

  def add_perk name
  end

  def perks_descriptions
    {
      :boxer => {
        :desc => 'punches do more damage.',
        :notify => 'learned to throw punches with purpose.'
      },
      :martial_artist => {
        :desc => 'punches do even more damage.',
        :notify => 'learned to fight quite effectively without weapons.'
      },
      :unarmed_master => {
        :desc => 'punches do devastating damage.',
        :notify => 'mastered striking without weapons.'
      },
      :barbarian => {
        :desc => 'melee weapons deal more damage.',
        :notify => 'learned to swing weapons with force.'
      },
      :slow_metabolism => {
        :desc => 'go twice as far without eating.',
        :notify => 'learned how to ignore the hunger.'
      },
      :desert_rat => {
        :desc => 'go twice as far without drinking.',
        :notify => 'learned to love the dry air.'
      },
      :evasive => {
        :desc => 'dodge attacks more effectively.',
        :notify => "learned to be where they're not."
      },
      :precise => {
        :desc => 'land blows more often.',
        :notify => 'learned to predict their movement.'
      },
      :scout => {
        :desc => 'see farther.',
        :notify => 'learned to look ahead.'
      },
      :stealthy => {
        :desc => 'better avoid conflict in the wild.',
        :notify => 'learned how not to be seen.'
      },
      :gastronome => {
        :desc => 'restore more health when eating.',
        :notify => 'learned to make the most of food.'
      }
    }
  end

  def has_perk? name
    @perks.include? name
  end

  def reset
  end

  def trigger_random_event
  end

  def tick_frame
  end

  def tick
    $game = self if !$game
  end

  def repopulate_recent_history
  end

  def has_upgrade? upgrade
  end

  def has_perk? name
  end

  def can_lift_off?
  end

  def percentage_lift_off
  end

  def upgrade_thrusters
  end

  def upgrade_hull
  end
end
